<?php

namespace FiloBlu\Design\Controller\Index;

use Magento\Framework\App\Action\Context;
use Magento\Framework\Controller\ResultFactory;
use FiloBlu\Amasty\GeoipRedirect\Observer\Redirect;

class GeoLocation extends \Magento\Framework\App\Action\Action
{

	/**
     * @var \Magento\Framework\HTTP\PhpEnvironment\RemoteAddress
     */
    protected $remoteAddress;
	/**
     * @var \Amasty\Geoip\Model\Geolocation
     */
    protected $geolocation;

	public $_directoryHelper;

	public function __construct(
    	Context $context,
		\Magento\Framework\HTTP\PhpEnvironment\RemoteAddress $remoteAddress,
		\Amasty\Geoip\Model\Geolocation $geolocation,
		\Magento\Directory\Helper\Data $directoryHelper
	) {
    	parent::__construct($context);
		$this->remoteAddress = $remoteAddress;
		$this->geolocation = $geolocation;
		$this->_directoryHelper = $directoryHelper;
	}

	public function execute()
	{
        //if xmlhttprequest

		if ($this->getRequest()->isXmlHttpRequest()) {

			$currentIp = $this->remoteAddress->getRemoteAddress();
			$location = $this->geolocation->locate($currentIp);

			if ($country = $location->getCountry()) {
				$response['country_code'] = $country;
			}
			else {
				$response['country_code'] = $this->_directoryHelper->getDefaultCountry();
			}

        	$resultJson = $this->resultFactory->create(ResultFactory::TYPE_JSON);
        	$resultJson->setData($response);

        	return $resultJson;
        }

		return null;

	}
}
?>
